"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.replaceWholeDoc = exports.createEditorView = void 0;

var _view = require("@codemirror/view");

var _state = require("@codemirror/state");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var replaceWholeDoc = function replaceWholeDoc(editor, nextValue) {
  editor === null || editor === void 0 ? void 0 : editor.dispatch({
    changes: {
      from: 0,
      to: editor.state.doc.length,
      insert: nextValue
    }
  });
};

exports.replaceWholeDoc = replaceWholeDoc;

var createEditorView = function createEditorView(parent, lastValueRef, extensions, onChangeRef) {
  return new _view.EditorView({
    state: _state.EditorState.create({
      extensions: [].concat(_toConsumableArray(extensions || []), [_view.EditorView.updateListener.of(function (viewUpdate) {
        if (viewUpdate.view.destroyed) return;
        var texts = [undefined, undefined];

        if (viewUpdate.docChanged) {
          var next = viewUpdate.state.doc.toString();
          var prev = lastValueRef.current;
          lastValueRef.current = next;
          texts = [next, prev];
        }

        var onChange = onChangeRef === null || onChangeRef === void 0 ? void 0 : onChangeRef.current;

        if (!onChange) {
          return;
        }

        onChange(viewUpdate, texts[0], texts[1]);
      })]),
      doc: lastValueRef.current
    }),
    parent: parent
  });
};

exports.createEditorView = createEditorView;