"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useExtension = void 0;

var _state = require("@codemirror/state");

var _react = _interopRequireDefault(require("react"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

var useExtension = function useExtension(ext, deps) {
  var compartment = _react["default"].useRef(new _state.Compartment());

  var hasInit = _react["default"].useRef(false);

  var extRef = _react["default"].useRef(ext);

  extRef.current = ext;

  var init = _react["default"].useCallback(function () {
    hasInit.current = true;
    return compartment.current.of(extRef.current());
  }, [hasInit, compartment, extRef]);

  var effects = _react["default"].useMemo(function () {
    if (!hasInit.current) return [];
    return [function updateExtension(editor) {
      editor.dispatch({
        effects: compartment.current.reconfigure(extRef.current())
      });
    }];
  }, [hasInit, extRef].concat(_toConsumableArray(deps || [])));

  return {
    init: init,
    effects: effects
  };
};

exports.useExtension = useExtension;